SystemOrganization addCategory: #KEGGeneratorFiniteStateMachines!

!KEGGenerator methodsFor: '*KEGGeneratorFiniteStateMachines' stamp: 'KjellGodo 6/8/2013 20:46'!
"(| defineMethod-:(" finiteSMParseHTML")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130603
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130603 20:13 )
	)-notes methodBody-:(
 (| let-:("| nonPairTags |")
    letBody-:("					"( MT b:#finiteSMParseHTML s:self )."
	( nonPairTags := #( '<meta' '<link' '<input' '<br>' ) ).
	^(
		( self finiteSMParseXML:[ :word | "<---[ word is the first word of a tag.  Return true if it is a nonPairTag ]"
			( nonPairTags includes: word )or:[ $!! = ( word at: 2 ) ] ] )

	)"return:( 					MT e:#finiteSMParseHTML s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Parse an HTML String into an Array tree of tag Strings and Strings between the tags.
	self is assumed to be a sequence of Characters as can be gotten
	by doing ( aString asSequence ).

 )-summary
 methodDescriptionDetail-:(

	Return a sequence of Arrays.

	See the testCases below

 )-detail
 usage-:(

	For more usages see below in the testCases.

 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'RichText>>bold:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(

	See KEGGeneratorTest>>testfiniteSMParseHTML for more tests.

	( '' asSequence finiteSMParseHTML ) asArray = #(  )

	( '<b>' asSequence finiteSMParseHTML ) asArray = #(  ) <-------------------------------------------------------[ Trailing unclosed leftParens are ignored ]

	( '<b></b>' asSequence finiteSMParseHTML ) asArray = #( ( ( '<b>'  '</b>' ) ) )

	( '<b></b><a>' asSequence finiteSMParseHTML ) asArray = #( ( ( '<b>'  '</b>' ) ) ) <-----------------[ Trailing unclosed leftParens are ignored ]

	( '<b><a></b>' asSequence finiteSMParseHTML ) asArray = #(  ) <------------------------------------------[ too many leftParens ]

	( '<a><b></b>' asSequence finiteSMParseHTML ) asArray = #(  ) <------------------------------------------[ too many leftParens ]

	[ ( '<b></b></a>' asSequence finiteSMParseHTML ) asArray = #(  ) ] on: Error do:[ :e | true ] <---[ too many rightParens ]

	( '<b><link ></b>' asSequence finiteSMParseHTML ) asArray = #( ( ( '<b>' '<link >' '</b>' ) ) )

	( '<link ><b></b>' asSequence finiteSMParseHTML ) inlineEmbeddedSequences asArray = #( '<link >'  ( '<b>' '</b>' ) )

	( '<b></b><br>' asSequence finiteSMParseHTML ) inlineEmbeddedSequences asArray = #( ( '<b>' '</b>' ) '<br>' )

	( '<b>a<h>d</h>g</b>' asSequence finiteSMParseHTML ) asArray = #( ( ( '<b>' 'a'  ( '<h>'  'd'  '</h>' ) 'g'  '</b>' ) ) )

	( '<b>a<b>d</h>g</h>' asSequence finiteSMParseHTML ) asArray = #( ( ( '<b>' 'a'  ( '<b>'  'd'  '</h>' ) 'g'  '</h>' ) ) ) <---[ No checking is done to verify that tags pair up ]

	( '<b>a<h>d</h>g</b>' asSequence finiteSMParseHTML ) inlineEmbeddedSequences asArray = #( ( '<b>' 'a'  ( '<h>'  'd'  '</h>' ) 'g'  '</b>' ) )

	( '<b><h></h></b>' asSequence finiteSMParseHTML ) asArray = #( ( ( '<b>'  ( '<h>'    '</h>' )  '</b>'  ) ) )

 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:(  )of-:(
		design
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGenerator methodsFor: '*KEGGeneratorFiniteStateMachines' stamp: 'KjellGodo 6/8/2013 20:50'!
"(| defineMethod-:(" finiteSMParseLeftParen: leftParenTest rightParen: rightParenTest collect: packageParens")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130528
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130529 14:10 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#finiteSMParseLeftParen:rightParen:collect: s:self )."
	^(
		
	  [ :returnArray :returnGen :stack :out | 
	  [ :returnArray2 :packagingGen | 
	  [ :notParenTest :popStack | | emit | 
		self sortInto:( KEGRuleBaseParam new "<-------------------------------------------------------------------[ Create a simple >>sortInto: based finite state machine with 2 states ]"
		"State( 1 )"when:[ :x | ( rightParenTest value: x ) not		ifTrue:[ 1 ]ifFalse:[ "<-------[ State 1 .  Push x onto the stack ]"
					    ( rightParenTest value: x )					ifTrue:[ 2 ] ] ] "<---------------[ pop the stack( reduce the stack ) and return nothing ]"
				here:[ :bag :x | stack add: x ] "<---------------------------------------------------------------------[ Push x onto the stack. Ignore this state's bag ]"
				leaving:[ :bag | KEGFooArray ] ; "<------------------------------------------------------------------[ Don't return anything ( KEGFooArray returns nothing ) ]"
		"State( 2 )"when:[ :x | ( rightParenTest value: x ) not		ifTrue:[ 1 ]ifFalse:[ "<-------[ State 2 .  pop the stack and if finished then return the result. When going to state 1 Push x onto the stack and try to emit a result but if not don't return anything ]"
					    ( rightParenTest value: x )					ifTrue:[ 2 ] ] ] "<---------------[ Stay in state 2 ]"
				here:[ :bag :x | emit := popStack value: x ] "<------------------------------------------------[ Do a compiler reduce operation on the stack ]"
				leaving:[ :bag | emit ifNil:[ KEGFooArray ] ] ; "<------------------------------------------------[ If we got a completed tree structure then return it otherwise don't return anything ]"
			yourself )
	] value:[ :x | ( ( leftParenTest value: x )or:[ rightParenTest value: x ] ) not ] "<-------------------[ :notParenTest ]"
	  value:[ :rightParen | "<---------------------------------------------------------------------------------------------------[ :popStack ]"
			( out removeAll ).
			( ( stack isEmpty )
				ifTrue:[ self error: 'Unbalanced parens' ]
				ifFalse:[ "<----------------------------------------------------------------------------------------------[ pop the stack and do a compiler reduce operation ]"
					( leftParenTest value: stack last )
						ifTrue:[ stack add:( packageParens value:( returnGen on:( returnArray2 p1:( stack removeLast ) p2:( rightParen ) ) ; yourself ) ) ]
						ifFalse:[ 
							( out add: rightParen ).
							( [ stack notEmpty and:[ ( leftParenTest value:( out add:( stack removeLast ) ) ) not ] ]whileTrue:[  ] )."<---[ pop the stack down to the left paren and into out ]"
							( ( leftParenTest value: out last ) 
								ifTrue:[ stack add:( packageParens value:( packagingGen on: out ; yourself ) ) ] "<-------------------------[ repackage the reversed out and push it. This is how the tree structure gets made ]"
								ifFalse:[ self error: 'Unbalanced parens' ] ) ] ] ).
			( ( stack size = 1 ) ifTrue:[ stack removeLast ] )
		  ]
	] value:( Array new: 2 ) "<---------------------------------------------[ :returnArray2 ]"
	  value:( KEGGenerator streamGenerator reverse )"<-------[ :packagingGen ]"
	] value:( Array new: 1 ) "<---------------------------------------------[ :returnArray ]"
	  value:( KEGGenerator streamGenerator ) "<-----------------[ :returnGen ]"
	  value:( OrderedCollection new ) "<-------------------------------[ :stack ]"
	  value:( OrderedCollection new ) "<-------------------------------[ :out ]"

	)"return:( 					MT e:#finiteSMParseLeftParen:rightParen:collect: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	self can be any sequence that has a tree like structure like XML or HTML or a lisp list.
	self can be a sequence of Characters like by ( aString asSequence ) or any sequence
	that has leftParens and rightParens in it.  If the parens are balanced then the returned
	sequence is a sequence of trees.  For instance : '(...)(...)(...)' would return a sequence
	of 3 trees.

 )-summary
 methodDescriptionDetail-:(

	leftParenTest 		is a monadicValuable that returns true iff the input is a leftParen
	rightParenTest 		is a monadicValuable that returns true iff the input is a rightParen
	packageParens		is a monadicValuable that returns an Array or other tree like structure

	An Array is a node that has no value but only children.  A monadicValuable is anything
	that responds to >>value: .

	self must start with a leftParen.  If it does not then #(  ) the empty sequence is returned.
	If any of the input tree sequences is unbalanced then the result is unpredictable and
	the KEGGenerator returned by self This Method may return nil from then on when
	sent the message >>next.  The balanced tree representations prior to that should get
	converted into trees properly.  self can't have any elements that are not between a leftParen
	and a rightParen.  If that happens then who knows what will happen.

 )-detail
 usage-:(

	For more usages see below in the testCases.

 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'RichText>>bold:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(

	See KEGGenerator>>finiteStateMachineParseParens for the tests.

 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:(  )of-:(
		design
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGenerator methodsFor: '*KEGGeneratorFiniteStateMachines' stamp: 'KjellGodo 6/8/2013 21:02'!
"(| defineMethod-:(" finiteSMParseLeftParenV1: leftParenTest rightParen: rightParenTest collect: packageParens")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130531
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130531 12:39 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#finiteSMParseLeftParenV1:rightParen:collect: s:self )."
	^(
		
	  [ :returnArray :returnGen :stack :out | "<------------------------------------------------------------------[ All these variables are immutable.  It's a functional style ]"
	  [ :returnArray2 :packagingGen | 
	  [ :notParenTest :popStack | | emit | "<----------------------------------------------------------------------[ Except for emit which has to be mutable( ie to be changeable ) ]"
		self sortInto:( KEGRuleBaseParam new "<-------------------------------------------------------------[ Create a simple >>sortInto: based finite state machine with 2 states ]"
		"<------------------------------------------------------------------------------------------------------------------------[ State 1 : The initial state we don't stay here and we never come back here ]"
		"State( 1 )"when:[ :x | ( leftParenTest value: x )			ifTrue:[ 2 ]ifFalse:[ "<-------[ Push x onto the stack and switch to state 2 returning nothing ]"
						( rightParenTest value: x )				ifTrue:[ self error: 'Unbalanced parens' ] "<---[ The first paren in self can't be a rightParen ]"
																ifFalse:[ 4 ] ] ] "<-------------[ We are not between any parens yet so add: x to state 4's bag and switch to state 4 returning nothing ]"
				here:[ :bag :x | nil ] "<-----------------------------------------------------------------------------[ add: nil to the bag of state 1 ie ignore this state's bag ]"
				leaving:[ :bag | KEGFooArray ] ; "<-----------------------------------------------------------[ Don't return anything when leaving this state ]"
		"<-----------------------------------------------------------------------------------------------------------------------[ State 2 : Push x onto the stack ]"
		"State( 2 )"when:[ :x | ( rightParenTest value: x )		ifTrue:[ 3 ] "<------------------[ pop the stack( reduce the stack ) and return nothing and switch to state 3 ]"
																ifFalse:[ 2 ] ] "<---------------[ Push x onto the stack and stay at state 2 ( no return unless you switch states ) ]"
				here:[ :bag :x | stack add: x ] "<--------------------------------------------------------------[ Push x onto the stack. Ignore this state's bag ]"
				leaving:[ :bag | KEGFooArray ] ; "<-----------------------------------------------------------[ Don't return anything ( KEGFooArray returns nothing when leaving a state ) ]"
		"<-----------------------------------------------------------------------------------------------------------------------[ State 3 : We got a rightParen so pop and reduce the stack ]"
		"State( 3 )"when:[ :x | ( ( emit notNil )and:[ rightParenTest value: x ] ) "<--------------[ We got an emit and another rightParen( with no leftParen ) ]"
													ifTrue:[ self error: 'Unbalanced parens' ]ifFalse:[ "<---[ The emit matched all the leftParens with rightParens already ]"
						( ( emit notNil )and:[ ( leftParenTest value: x ) not ] ) "<---------------[ We got an emit and x is not leftParen and not rightParen ]"
													ifTrue:[ 4 ] ifFalse:["<------------------------[ add: x to state 4's bag and return the emit or nothing ]"
						( rightParenTest value: x )	ifTrue:[ 3 ] "<------------------------------------[ Pop the stack and do a reduce operation staying in state 3 maybe we get an emit ]"
													ifFalse:[ 2 ] ] ] ] "<-----------------------------[ Push x onto the stack and switch to state 2 returning the emit or nothing ]"
				here:[ :bag :x | emit := popStack value: x ] "<------------------------------------------[ Do a compiler reduce operation on the stack and signal completion or nil ]"
				leaving:[ :bag | emit ifNil:[ KEGFooArray ] "<---------------------------------------------[ Don't return anything when leaving this state 3 ]"
							     ifNotNil:[ :e | ( emit := nil ).( returnArray p1: e ) ] ] ; "<--------[ If we got a completed tree structure then return it when leaving this state 3 ]"
		"<------------------------------------------------------------------------------------------------------------------------[ State 4 : We are not between any parens so just return all non parens in state 4's bag ]"
		"State( 4 )"when:[ :x | ( rightParenTest value: x )	ifTrue:[ self error: 'Unbalanced parens' ]ifFalse:[ "<---[ We are not between any parens ]"
					        ( leftParenTest value: x )			ifTrue:[ 2 ] "<--------------------------[ Push x onto the stack and switch to state 2 returning state 4's bag ]"
															ifFalse:[ 4 ] ] ] "<---------------------[ Stay at state 4 and add: x to state 4's bag ]"
				here:[ :bag :x | x ] "<---------------------------------------------------------------------------------[ add: x to state 4's bag ( each state's bag is an OrderedCollection ) ]"
				leaving:[ :bag | bag ] ; "<---------------------------------------------------------------------------[ Return bag.  This occures when ( r next ) is evaluated and we change state away from state 4 ]"
		"<--------------------------------------------------------------------------------------------------------------------------[  ]"
			yourself )
	] value:[ :x | ( ( leftParenTest value: x )or:[ rightParenTest value: x ] ) not ] "<---------------[ :notParenTest  : not used ]"
	  value:[ :rightParen | "<-----------------------------------------------------------------------------------------------[ :popStack       : Do a compiler reduce operation on the stack ]"
			( out removeAll )."<-----------------------------------------------------------------------------------------[ Reset the reduce operation of the left overs from previous reduce operations ]"
			( ( stack isEmpty ) "<---------------------------------------------------------------------------------------[ Something should have been pushed onto the stack by now ]"
				ifTrue:[ self error: 'Unbalanced parens' ]"<------------------------------------------------[ This might never be evaluated because of the tests above. Just in case we do it ]"
				ifFalse:[ "<------------------------------------------------------------------------------------------------[ pop the stack and do a compiler reduce operation ]"
					( leftParenTest value: stack last ) "<---------------------------------------------------[ leftParen is on top of the stack ]"
						ifTrue:[ stack add:( packageParens value:( returnGen on:( returnArray2 p1:( stack removeLast ) p2:( rightParen ) ) ; yourself ) ) ] "<---[ Push an empty tree node onto the stack ]"
						ifFalse:[ "<------------------------------------------------------------------------------------[ The leftParen and rightParen have non paren elements between them on the stack.  The rightParen is not on the stack ]"
							( out add: rightParen ). "<-------------------------------------------------------[ out is in the reverse order of what you would expect ]"
							( [ stack notEmpty and:[ ( leftParenTest value:( out add:( stack removeLast ) ) ) not ] ]whileTrue:[  ] )."<---[ pop the stack down to the left paren and into out ]"
							( ( leftParenTest value: out last ) "<----------------------------------------[ Out has both parens and the elements between ]"
								ifTrue:[ stack add:( packageParens value:( packagingGen on: out ; yourself ) ) ] "<---[ repackage the reversed out and push it. This is how the tree structure gets made ]"
								ifFalse:[ self error: 'Unbalanced parens' ] ) ] ] )."<-------------[ Not enough leftParens to match the rightParens.  We ran out ]"
			( ( stack size = 1 ) ifTrue:[ stack removeLast ] )
		  ]
	] value:( Array new: 2 ) "<------------------------------------------------[ :returnArray2 	is used to return empty tree nodes ]"
	  value:( KEGGenerator streamGenerator reverse )"<-------[ :packagingGen 	is used to reverse the out ]"
	] value:( Array new: 1 ) "<-------------------------------------------------[ :returnArray	is used to return the emit so that >>inlineEmbeddedSequences can be used ]"
	  value:( KEGGenerator streamGenerator ) "<--------------------[ :returnGen 		is used to return empty tree nodes ]"
	  value:( OrderedCollection new ) "<---------------------------------[ :stack 			is the main engine that builds the trees ]"
	  value:( OrderedCollection new ) "<---------------------------------[ :out  			is used in the reduce operation on the stack to get the top of the stack ]"

	)"return:( 					MT e:#finiteSMParseLeftParenV1:rightParen:collect: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a KEGGenerator.  Let us call this returned KEGGenerator by the name r .

	self can be any sequence that has tree like structures like XML or HTML or lisp lists in it.
	self can be a sequence of Characters like by ( aString asSequence ) or any sequence
	that has leftParens and rightParens in it.  If the parens are balanced then the returned
	sequence is a sequence of trees.  For instance : '...(...)...(...)...(...)...' would return a sequence
	of 3 trees with zero or more untreed elements between the 3 trees if you remember to use
	>>inlineEmbeddedSequences on r .  Like ( answer := r inlineEmbeddedSequences ).

 )-summary
 methodDescriptionDetail-:(

	Otherwise you will get   r = < OC( ... ) #( (...) ) OC( ... ) #( (...) ) OC( ... ) #( (...) ) OC( ... ) >
	where OC( ... ) is an OrderedCollection which is the bag for state 4 above in the >>sortInto:
	constructed finite state machine and
	#( (...) ) represents a tree structure in an Array.  All the OCs above are the same OC but
	with different contents each time.
	( r inlineEmbeddedSequences ) = < ... (...) ... (...) ... (...) ... >
	which is what you want.  If there are no ... outside of the trees then maybe you can get
	by without using >>inlineEmbeddedSequences on r to finish things up

	leftParenTest 		is a monadicValuable that returns true iff the input is a leftParen
	rightParenTest 		is a monadicValuable that returns true iff the input is a rightParen
	packageParens		is a monadicValuable that returns an Array or other tree like structure

	An Array is a node in a tree it has no value but only children.  Or you could designate one
	of the Array elements as the value and the rest of the elements as the children.
	A monadicValuable is anything that responds to >>value: .

	self doesn't have to start with a leftParen.
	If any of the input tree sequences is unbalanced then an error is signaled.
	If there are too many leftParens then any unclosed leftParens will be ignored but closed
	leftParens will be returned by ( r next ) expressions.  
	The balanced tree representations prior to that should get converted into trees properly.
	If there are too many rightParens there will be an error signaled.

 )-detail
 usage-:(

	For more usages see below in the testCases.  Also see the references to self This Method
	and their tests.

 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'RichText>>bold:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(

	See KEGGenerator>>finiteStateMachineParseParensV1 for the tests.

 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:(  )of-:(
		design
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGenerator methodsFor: '*KEGGeneratorFiniteStateMachines' stamp: 'KjellGodo 6/8/2013 21:05'!
"(| defineMethod-:(" finiteSMParseXML: isANonPairTag ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130603
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130603 19:14 )
	)-notes methodBody-:(
 (| let-:("| isLeftParen firstWordGen isANonPairTag1 nonPairTags |")
    letBody-:("					"( MT b:#finiteSMParseXML: s:self )."
	( isANonPairTag1 := isANonPairTag isSequence 
		ifTrue:[ 
			( nonPairTags := ( isANonPairTag size < 8 )
				ifTrue:[ isANonPairTag asGenerator asArray ]
				ifFalse:[ isANonPairTag asGenerator asSet ] ).
			[ :word | nonPairTags includes: word ] ]
		ifFalse:[ isANonPairTag ] ).
	( firstWordGen := KEGGenerator streamGenerator upTo: $  )."<-----------------------------------[ This also handles the case where there is no blank $  Character ]"
	( isLeftParen := [ :s1 | ( s1 first = $< )and:[ s1 last = $> ] ] ).
	^(
		( self finiteSMParseXMLTags "<------------------------------------------------------------------------------[ Lex self into a sequence of tag Strings and non tag Strings ]"
		) finiteSMParseLeftParenV1:( [ :s | "<----------------------------------------------------------------------[ Define the left paren to be a left XML tag ]"
			( isLeftParen value: s )and:[ 
			( isANonPairTag1 value: ( firstWordGen on: s ; asString ) ) not ] ] )
		  rightParen:[ :s | ( isLeftParen value: s )and:[ ( s at:( 2 ) ) = $/ ] ] "<-------------------------[ Define the right paren to be a left paren with a $/ at the front ]"
		  collect:[ :gen | gen asArray ] "<-----------------------------------------------------------------------------[ Produce a tree of Arrays ]"

	)"return:( 					MT e:#finiteSMParseXML: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Parse an XML String into an Array tree of tag Strings and Strings between the tags.
	self is assumed to be a sequence of Characters as can be gotten
	by doing ( aString asSequence ).

	isANonPairTag is a monadicValuable that takes in a String which is the first nonBlank
	word of a tag.  If there are no blanks in the tag then the whole tag is the input.  This
	isANonPairTag returns true iff the tag is a non pair tag which means that the tags don't
	come in <tag></tag> pairs because only the <tag> part ever exists.

	Or isANonPairTag can be a >>isSequence sequence of Strings which should be
	the first word of tags that are non pairs.  Like '<meta'  '<link'  '<!!--'  etc.

	monadicValuables are anything that respondsTo: #value:

 )-summary
 methodDescriptionDetail-:(

	Return a sequence of Arrays.  Usually there will only be one Array in the sequence.
	But there can be more.
	There can be nonPairTags by themselves outside of the paren pairs.  There can
	be arbitrary Strings between the paren pairs.  If this is no good then use
	finiteSMParseLeftParen: instead of finiteSMParseLeftParenV1: above.

	See the testCases below

	We allow that some tags don't come
	as pairs.  Only the leftParen is used.  This can cause the parsing not to work because
	there are not enough rightParens to balance all the leftParens.  leftParen = <...>
	rightParen = </...>.  So we have to make a list of all the leftParens that can come
	without any rightParen.  This is done in the nonPairTags Set above.  We don't really
	know what all the nonPairTags are.

 )-detail
 usage-:(

	For more usages see below in the testCases.

 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'RichText>>bold:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(

	See KEGGeneratorTest>>finiteSMParseXMLC for more tests.

	( '' asSequence finiteSMParseXML:#(  ) ) asArray = #(  )

	( '<b>' asSequence finiteSMParseXML:#(  ) ) asArray = #(  ) <---[ unclosed leftParens are ignored ]

	( '<b></b>' asSequence finiteSMParseXML:#(  ) ) asArray = #( ( ( '<b>' '</b>' ) ) )

	( '<b></b>' asSequence finiteSMParseXML:#(  ) ) inlineEmbeddedSequences asArray = #( ( '<b>' '</b>' ) )

	( '<b></b><a>' asSequence finiteSMParseXML:#(  ) ) asArray = #( ( ( '<b>'  '</b>' ) ) ) <---[ unclosed leftParen near the end are ignored ]

	( '<b></b><a >' asSequence finiteSMParseXML:#( '<a' ) ) asArray asString = '#(#(#(''<b>'' ''</b>'')) an OrderedCollection(''<a >''))' <---[ OC is reused and has the last thing that was put into it here. >>inlineEmbeddedSequences fixes that ]

	( '<b></b><a >' asSequence finiteSMParseXML:#( '<a' ) ) inlineEmbeddedSequences asArray = #( ( '<b>' '</b>' ) '<a >' ) <---[ Handle tags with blanks in them ]

	( '<b></b><a>' asSequence finiteSMParseXML:#( '<a>' ) ) inlineEmbeddedSequences asArray = #( ( '<b>' '</b>' ) '<a>' ) <---[ <a> is not a leftParen ]

	( '<b><a></b>' asSequence finiteSMParseXML:#(  ) ) asArray = #(  ) <---[ Too many leftParens ]

	( '<a><b></b>' asSequence finiteSMParseXML:#(  ) ) asArray = #(  ) <---[ Too many leftParens ]

	[ ( '<b></b></a>' asSequence finiteSMParseXML:#(  ) ) asArray = #(  ) ] on: Error do:[ :e | true ] <---[ Too many rightParens ]

	( '<b><link ></b>' asSequence finiteSMParseXML:#( '<link' ) ) asArray = #( ( ( '<b>' '<link >' '</b>' ) ) )

	( '<link ><b></b>' asSequence finiteSMParseXML:#( '<link' ) ) asArray asString = '#(an OrderedCollection() #(#(''<b>'' ''</b>'')))' <---[ The OrderedCollection is reused and so it gets emptied ]

	( '<link ><b></b>' asSequence finiteSMParseXML:#( '<link' ) ) inlineEmbeddedSequences asArray = #( '<link >' ( '<b>' '</b>' ) )

	( '<link blablabla><b></b>' asSequence finiteSMParseXML:#( '<link' ) ) inlineEmbeddedSequences asArray = #( '<link blablabla>' ( '<b>' '</b>' ) )

	( '<link><b></b>' asSequence finiteSMParseXML:#( '<link>' ) ) inlineEmbeddedSequences asArray = #( '<link>' ( '<b>' '</b>' ) )

	( '<b><br></b>' asSequence finiteSMParseXML:#( '<br>' ) ) inlineEmbeddedSequences asArray = #( ( '<b>'  '<br>'  '</b>' ) )

	( '<b>a<h>d</h>g</b>' asSequence finiteSMParseXML:#(  ) ) asArray = #( ( ( '<b>' 'a'  ( '<h>'  'd'  '</h>' ) 'g'  '</b>' ) ) )

	( 'e<b>a<h>d</h>g</b>f' asSequence finiteSMParseXML:#(  ) ) inlineEmbeddedSequences asArray = #( 'e' ( '<b>' 'a' ( '<h>' 'd' '</h>' ) 'g' '</b>' ) 'f' )

	( '<b><h></h></b>' asSequence finiteSMParseXML:#(  ) ) asArray = #( ( ( '<b>'  ( '<h>'    '</h>' )  '</b>'  ) ) )

 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:(  )of-:(
		design
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGenerator methodsFor: '*KEGGeneratorFiniteStateMachines' stamp: 'KjellGodo 6/8/2013 21:07'!
"(| defineMethod-:(" finiteSMParseXMLTags")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130529
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130529 19:51 )
	)-notes methodBody-:(
 (| let-:("| asStringGen |")
    letBody-:("					"( MT b:#finiteSMParseXMLTags s:self )."
	( asStringGen := KEGGenerator streamGenerator ).
	^(
		self finiteSMParseXMLTags:[ :oc | ( asStringGen on: oc ) asString ] collect:[ :oc | ( asStringGen on: oc ) asString ]

	)"return:( 					MT e:#finiteSMParseXMLTags s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Parse an XML String into tag Strings and Strings between the tags.
	self is assumed to be a sequence of Characters as can be gotten
	by doing ( aString asSequence ).

 )-summary
 methodDescriptionDetail-:(

	Return a sequence of Strings.

	See the testCases below

 )-detail
 usage-:(

	For more usages see below in the testCases.

 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'RichText>>bold:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(

	See KEGGeneratorTest>>testfiniteSMParseXMLTags for more tests.

	( '' asSequence finiteSMParseXMLTags ) asArray = #(  )

	( '<b>' asSequence finiteSMParseXMLTags ) asArray = #( '<b>' )

	( '<b>a<h>d</h>g</b>' asSequence finiteSMParseXMLTags ) asArray = #( '<b>' 'a'  '<h>'  'd'  '</h>'  'g'  '</b>' )

	( '<b><h></h></b>' asSequence finiteSMParseXMLTags ) asArray = #( '<b>'   '<h>'    '</h>'   '</b>'  )

 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:(  )of-:(
		design
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGenerator methodsFor: '*KEGGeneratorFiniteStateMachines' stamp: 'KjellGodo 6/8/2013 21:56'!
"(| defineMethod-:(" finiteSMParseXMLTags: packageTags collect: packageNonTags")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130529
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130529 19:01 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#finiteSMParseXMLTags:collect: s:self )."
	^(
		self sortInto:( KEGRuleBaseParam new "<--------------------------------------------------------[ Create a simple >>sortInto: based finite state machine with 2 states ( the bags are OrderedCollections ) ]"
			"1"when:[ :x | ( x = $< )						ifTrue:[ 2 ] "<--------------------------[ State 1 .  add: x ( = $< ) to the state 2 bag and switch to state 2 ]"
														ifFalse:[ 1 ] ] "<-----------------------[ Stay here at state 1 and stick x into the bag for state 1 ]"
				here:( nil ) "<--------------------------------------------------------------------------------------[ Remember nil = [ :na :x | x ] so stick x into state 1 bag ]"
				leaving:[ :bag | bag ifEmpty:[ KEGFooArray ] "<-----------------------------------[ If bag is empty then don't return anything ]"
							     ifNotEmpty:( packageNonTags ) ] ; "<--------------------------[ When we leave state 1 and go to state 2 then Package the state 1 bag with non tag Characters in it ]"
			"2"when:[ :x | ( x = $> ) 					ifTrue:[ #( 1 ) ] "<-------------------[ State 2 .  add x ( = $> ) to the state 2 bag and switch to state 1 ]"
														ifFalse:[ 2 ] ] "<----------------------[ Stay in state 2 and stick x into the bag for state 2 ]"
				here:( nil ) "<--------------------------------------------------------------------------------------[ Stick x into state 2 bag ]"
				leaving:[ :bag | bag ifEmpty:[ KEGFooArray ] "<-----------------------------------[ If bag is empty then don't return anything ]"
							     ifNotEmpty:( packageTags ) ] ; "<--------------------------------[ When we leave state 2 and go to state 1 then Package the state 2 bag with tag Characters in it ]"
			yourself )

	)"return:( 					MT e:#finiteSMParseXMLTags:collect: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Parse an XML String into tag sequences and sequences between the tags.
	self is assumed to be a sequence of Characters as can be gotten
	by doing ( aString asSequence ).

	packageTags is a monadicValuable that takes in an OrderedCollection which
	has the Characters in it for a tag.  Usually this would return a String.

	packageNonTags is a monadicValuable that takes in an OrderedCollection
	which has the Characters in it for a non tag which is between tags or outside
	of a tag.  Usually this would return a String.

	a monadicValuable is anything that respondsTo: #value: like a [ :x | ... ].

 )-summary
 methodDescriptionDetail-:(

	The returned bags are two OrderedCollections that is returned over and over
	with different contents. One for each of the two states.  So if you want these
	sequences to persist then you have to >>copy them or do >>asArray etc.
	If you don't need them to persist for very long then just use them as is.
	But be careful about the data suddenly vanishing on the next call to ( r next )
	where r is the KEGGenerator returned by self This Method.  So
	( r collect:[ :oc | oc asArray ] ) or ( r collect:[ :oc | oc copy ] ) would return more
	persistent sequences.

	See the testCases below

 )-detail
 usage-:(

	For more usages see below in the testCases.

 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'RichText>>bold:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(

	See KEGGenerator>>finiteSMParseXML: or >>finiteSMParseHTML for more tests.

	( '' asSequence finiteSMParseXMLTags:[ :bag | bag asArray ] collect:[ :bag | bag asArray ] ) asArray = #(  )

	( '<b>' asSequence finiteSMParseXMLTags:[ :bag | bag asArray ] collect:[ :bag | bag asArray ] ) asArray = #( ( $< $b $> ) )

	( '<b>a<h>d</h>g</b>' asSequence finiteSMParseXMLTags:[ :bag | bag asArray ] collect:[ :bag | bag asArray ] ) asArray = #( ( $< $b $> )( $a )( $< $h $> )( $d )( $< $/ $h $> )( $g )( $< $/ $b $> ) )

	( '<b><h></h></b>' asSequence finiteSMParseXMLTags:[ :bag | bag asArray ] collect:[ :bag | bag asArray ] ) asArray = #( ( $< $b $> )( $< $h $> )( $< $/ $h $> )( $< $/ $b $> ) )

 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:(  )of-:(
		design
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGenerator methodsFor: '*KEGGeneratorFiniteStateMachines' stamp: 'KjellGodo 6/8/2013 21:13'!
"(| defineMethod-:(" finiteStateMachineParseParens ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130529
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130529 14:26 )
	)-notes methodBody-:(
 (| let-:("| packagingGen |")
    letBody-:("					"( MT b:#finiteStateMachineParseParens s:self )."
	( packagingGen := KEGGenerator streamGenerator removeLast removeFirst )."<---[ removeFirst must come second because of a speed optimization ]"
	^(
		( self finiteSMParseLeftParen:[ :x | x = $( ] rightParen:[ :x | x = $) ] collect:[ :gen | ( packagingGen onGenerator: gen ; yourself ) asArray ] )

	)"return:( 					MT e:#finiteStateMachineParseParens s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	self should be a sequence of Characters which looks like a lisp list.
	Then a KEGGenerator is returned that has one single Array element
	which is an Array version of the lisp list. Or if there were multiple
	lists in a sequence in self then the returned KEGGenerator is
	a sequence of Arrays one for each list.  If the parens are unbalanced
	then there will be an Error signaled.  There can't be any elements
	of self that aren't in a list.  I believe the empty sequence is returned
	in that case or trailing elements of self not in lists will be ignored.
	The whole thing will go cockeyed.

 )-summary
 methodDescriptionDetail-:(

	If self looks like '(abc((def)ghi)jkm)' then the returned Array will look
	like #( $a $b $c ( ( $d $e $f ) $g $h $i ) $j $k $m ) for example.

	Or self could be an arbitrary sequence of Objects but with $( and $)
	Characters in it like in a lisp list.

	I don't know that this is really useful for anything but it shows what can
	be done with >>finiteSMParseLeftParen:rightParen:collect:
	and with >>sortInto: when you include a stack in the mix for looping
	recursion.  You can do simple shift reduce parsing with an added stack.
	
 )-detail
 usage-:(

	For more usages see below in the testCases.

 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'RichText>>bold:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(

	'()' asSequence finiteStateMachineParseParens asArray = #( (  ) )

	'(abc)' asSequence finiteStateMachineParseParens asArray = #( ( $a $b $c ) )

	'(a(b(c)))' asSequence finiteStateMachineParseParens asArray = #( ( $a ( $b ( $c ) ) ) )

	[ '(a(b(c))))' asSequence finiteStateMachineParseParens asArray ]on: Error do:[ :e | true ] <---[ Too many rightParens ]

	'((a(b(c)))' asSequence finiteStateMachineParseParens asArray = #(  ) <---[ Too many leftParens ]

	'(((a)b)c)' asSequence finiteStateMachineParseParens asArray = #( ( ( ( $a ) $b ) $c ) )

	'(abc(()ghi)jkm)' asSequence finiteStateMachineParseParens asArray = #( ( $a $b $c ( (  ) $g $h $i ) $j $k $m ) )

	'(abc((def)ghi)jkm)' asSequence finiteStateMachineParseParens asArray = #( ( $a $b $c ( ( $d $e $f ) $g $h $i ) $j $k $m ) )

	'(abc((def)ghi)jkm)(nop)' asSequence finiteStateMachineParseParens asArray = #( ( $a $b $c ( ( $d $e $f ) $g $h $i ) $j $k $m ) ( $n $o $p ) )

	'(abc(def(ghi))jkm)(n(o(p)))' asSequence finiteStateMachineParseParens asArray = #( ($a $b $c ( $d $e $f ( $g $h $i ) ) $j $k $m ) ( $n ( $o ( $p ) ) ) )

 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:(  )of-:(
		design
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGenerator methodsFor: '*KEGGeneratorFiniteStateMachines' stamp: 'KjellGodo 6/8/2013 21:13'!
"(| defineMethod-:(" finiteStateMachineParseParensV1 ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20130531
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20130531 14:50 )
	)-notes methodBody-:(
 (| let-:("| packagingGen |")
    letBody-:("					"( MT b:#finiteStateMachineParseParensV1 s:self )."
	( packagingGen := KEGGenerator streamGenerator removeLast removeFirst )."<---[ removeFirst must come second because of a speed optimization ]"
	^(
		( self finiteSMParseLeftParenV1:[ :x | x = $( ] rightParen:[ :x | x = $) ] collect:[ :gen | ( packagingGen onGenerator: gen ; yourself ) asArray ] )

	)"return:( 					MT e:#finiteStateMachineParseParensV1 s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	self should be a sequence of Characters which looks like a lisp list.
	Then a KEGGenerator is returned that has zero or more Array elements
	which is an Array version of the lisp list. Or if there were multiple
	lists in a sequence in self then the returned KEGGenerator is
	a sequence of Arrays one for each list.  If the parens are unbalanced
	then there will be an Error signaled.  If there aren't enough rightParens
	then the empty sequence is returned but no Error is signaled.  If you
	want an Error in that case then a new version of
	>>finiteSMParseLeftParenV1:rightParen:collect:
	will have to be made such that a lookAhead is done which would be
	bad for backTracking.

 )-summary
 methodDescriptionDetail-:(

	If self looks like '(abc((def)ghi)jkm)' then the returned Array will look
	like #( $a $b $c ( ( $d $e $f ) $g $h $i ) $j $k $m ) for example.

	Or self could be an arbitrary sequence of Objects but with $( and $)
	Characters in it like in a lisp list.

	I don't know that this is really useful for anything but it shows what can
	be done with >>finiteSMParseLeftParenV1:rightParen:collect:
	and with >>sortInto: when you include a stack in the mix for looping
	recursion.  You can do simple shift reduce parsing with an added stack.
	
 )-detail
 usage-:(

	For more usages see below in the testCases.

 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'RichText>>bold:' )
 )-todebug
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(

	'' asSequence finiteStateMachineParseParensV1 asArray = #(  )

	'abc' asSequence finiteStateMachineParseParensV1 inlineEmbeddedSequences asArray = #( $a $b $c )

	'()' asSequence finiteStateMachineParseParensV1 asArray = #( ( ( ) ) )

	'(a)' asSequence finiteStateMachineParseParensV1 asArray = #( ( ( $a ) ) )

	'(a(d(g)))' asSequence finiteStateMachineParseParensV1 asArray = #( ( ( $a ( $d ( $g ) ) ) ) )

	'(a(d(g))' asSequence finiteStateMachineParseParensV1 asArray = #(  ) <-----------------------------------------------------------------------------[ Too few rightParens ]

	[ ')' asSequence finiteStateMachineParseParensV1 asArray = #( ( ( $a ( $d ( $g ) ) ) ) ) ]on:Error do:[ :e | true ] <---------------------[ Too few leftParens ]

	[ 'abc)' asSequence finiteStateMachineParseParensV1 asArray = #( ( ( $a ( $d ( $g ) ) ) ) ) ]on:Error do:[ :e | true ] <---------------[ Too few leftParens ]

	[ '(a(d(g))))' asSequence finiteStateMachineParseParensV1 asArray = #( ( ( $a ( $d ( $g ) ) ) ) ) ]on:Error do:[ :e | true ] <----------[ Too few leftParens ]

	'(abc(def(ghi)))' asSequence finiteStateMachineParseParensV1 asArray = #( ( ( $a $b $c ( $d $e $f ( $g $h $i ) ) ) ) )

	'(abc((def)ghi)jkm)' asSequence finiteStateMachineParseParensV1 asArray = #( ( ( $a $b $c ( ( $d $e $f ) $g $h $i ) $j $k $m ) ) )

	'(abc((def)ghi)jkm)(nop)' asSequence finiteStateMachineParseParensV1 inlineEmbeddedSequences asArray = #( ($a $b $c ( ( $d $e $f ) $g $h $i ) $j $k $m ) ( $n $o $p ) )

	'(abc((def)ghi)jkm)(abc(def(ghi)))' asSequence finiteStateMachineParseParensV1 inlineEmbeddedSequences asArray = #( ( $a $b $c ( ( $d $e $f ) $g $h $i ) $j $k $m ) ( $a $b $c ( $d $e $f ( $g $h $i ) ) ) )

	'1(a(()g)k)4(n)7' asSequence finiteStateMachineParseParensV1 inlineEmbeddedSequences asArray = #( $1 ( $a ( (  ) $g ) $k ) $4 ( $n ) $7 )

	'123(abc((def)ghi)jkm)456(nop)789' asSequence finiteStateMachineParseParensV1 inlineEmbeddedSequences asArray = #( $1 $2 $3 ($a $b $c ( ( $d $e $f ) $g $h $i ) $j $k $m ) $4 $5 $6 ( $n $o $p ) $7 $8 $9 )

 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:(  )of-:(
		design
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGenerator methodsFor: '*KEGGeneratorFiniteStateMachines' stamp: 'KjellGodo 6/8/2013 21:17'!
"(| defineMethod-:(" sectionsStartingWith: sectionPrefixBoundary ")
	notes-:(		Method Version: keg2.
				 Copyright Kjell E God 20020423
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030406 20020423
	)-notes methodBody-:(
 (| let-:("| testBlk prefix |")
    letBody-:("					"( MT b:#sectionsStartingWith: s:self )."

	^(	(	( sectionPrefixBoundary isKindOf:( BlockClosure ) )		or:[
			( sectionPrefixBoundary respondsTo:( #value: ) )			]
		) ifTrue:[ 
			( testBlk := sectionPrefixBoundary ).
			( self sortInto:( KEGRuleBaseParam new
				"1"when:[ :x | ( testBlk value: x ) ifTrue:[ 2 ]ifFalse:[ 1 ] ]   perform:( nil ); "<---( Remember that nil = [ :b :x | x ] the empty 2 parameter BlockClosure.  And sortInto: ... perform:[ :b :x | x ] means stick x into the bag for self( this state( state ''1'' ) ) and when you are leaving self( this state( state 1 ) ) then return the bag for self( this state( state 1 ) ).  The two states are labelled ''1'' and ''2''. )"
				"2"when:[ :x | ( testBlk value: x ) ifTrue:[ 1 ]ifFalse:[ 2 ] ]   perform:( nil )
				)
			) ]
		ifFalse:[ 
		    ( prefix := sectionPrefixBoundary ).
		    ( self sortInto:( KEGRuleBaseParam new
		        "1"when:[ :x | ( x = prefix ) ifTrue:[ 2 ]ifFalse:[ 1 ] ]   perform:( nil ); "<---( nil is used instead of [ :x | x ] because in the SortedCollection class>>value:value: it is insinuated that any non BlockClosure implementation of the >>value: message will be faster than the one for BlockClosures. )"
		        "2"when:[ :x | ( x = prefix ) ifTrue:[ 1 ]ifFalse:[ 2 ] ]   perform:( nil )
		        )
		    ) ]
	)"return:( 					MT e:#sectionsStartingWith: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a sequence of sequences( IE: return a sequence of OrderedCollections( 
		ie: sortInto: bags ) )
	( IE: return a Generator of OrderedCollections ).
	The simplest case is where self = < s1 s2 s3 ... P a1 a2 a3 ... P b1 b2 b3 ... >
	And then the sequence returned by self-:( this method ) is-:
	< OC( s1 s2 s3 ... sN ) OC( P a1 a2 a3 ... aM ) OC( P b1 b2 b3 ... ) ... >
	where M is a Natural and N is an Integer where 0 <= N .
	( The Natural numbers are < 1 2 3 4 ... > )

 )-summary
 methodDescriptionDetail-:(

	( In the sortInto: lingo the subSequences returned by the Generator returned
		by the KEGGenerator>>sortInto: method are called bags.  But they are
		not instances of the Bag Class.  They are an OrderedCollection. )( lingo
		means specialized language-:( for those of you who don't speak US American.
		American, as opposed to English. ) )
	Please note that the OrderedCollections OC returned is always the same OC so
	if you want to do-:(
		(
		( 
		( 'a car a bus a truck' asSequence
		)  sectionsStartingWith: $a 
		) asOrderedCollection 
		)

	)-do
	you won't get what you expect.  In order to get what you expect you will have
	to instead do-:(
		(
		(
		(
		( 'a car a bus a truck' asSequence
		) sectionsStartingWith:( $a )
		) collect:[ :oc | oc copy ] 
		) asOrderedCollection 
		)

	)-do.
	Also please see the methods-:(
		. . . . . . . . . . . .
		KEGGenerator>>sortIntoChangeOCsToGenerators
		KEGGenerator>>sortIntoChangeOCsToStringGenerators
		. . . . . . . . . . . .
	)and the KEGGeneratorFiniteStateMachines package .

	Suppose self = 
	   <	s1 s2 s3 ... sK
		P1   s11 s12 s13... s1N 
		P2   s21 s22 s23 ... s2M  
		P3   s31 s32 s33 ... s3G
		P4 ... >
	THEN-: the answer returned from self( this method ) = r = < r0  r1  r2  r3 ... >
	and P = sectionPrefixBoundary
	Then
		r0 = OC( s1 s2 s3 ... sK )
		r1 = OC( P1   s11 s12 s13... s1N )
		r2 = OC( P2   s21 s22 s23 ... s2M )
		r3 = OC( P3   s31 s32 s33... s3G )
			etc . . .
	where s1N = s( 1, N ), s23 = s( 2, 3 ), etc . . . where( 0 <= K )and( 0 <= N )
		and( 0 <= M ) and( 0 <= G ) etc. are Integers, and
		the-:(   s11 s12 s13... s1N   ) notations mean 0 or more elements in a sequence,
		So OC( s1 s2 s3 ... sK ) might very well be empty and so equal to OC(  )
		the empty OrderedCollection, as can be seen in the testCase below,
	where EITHER-:(
		P1 = sectionPrefixBoundary
		P2 = sectionPrefixBoundary
		P3 = sectionPrefixBoundary
		     . . .
		orCase2-:
		( sectionPrefixBoundary value:( Pi ) ) = true		for i = 1 2 3 ...
			and-:
			( sectionPrefixBoundary value:( x ) ) = false
			for all x that are not elements of the Set-:{  P1 , P2 , P3 ...  }
	).
	Case2 is because sectionPrefixBoundary can be a single parameter
	BlockClosure or monadicValuable( ie: it responds to the >>value: message. ).

	In other words return all the subSequences of self that start with
	sectionPrefixBoundary .

	In other words return the ( P * ) subSequences which match with self like
	in some psuedo regular expression matching pattern-:
		* ( sectionPrefixBoundary * )*

	A frequently used function relating to Strings is-:(

		( 'somePrefixString' )containedIn:( x )

	). Like if you were to do-:(
		(
		( someText linesStrGen 
		) sectionsStartingWith:[ :ln | ( 'somePrefixString' )containedIn:( ln ) ]
		)

	) where someText is a text String of multiple seperate lines ie: it includes-:(

		( String lineDelimiter ) 

	) Character subSequences .

	In order to get linesStrGen you need to install the
	KEGStringGeneratorFileStream-6-0.pac Package( Dolphin Smalltalk ).

 )-detail
 usage-:(

	Here is some as yet untested code which might be used to section up RichText
	into colored and Fonted subSections-:(

		(											Array p1:
			( aRichText rtf )								p2:
			[ :str | 
				( nextWord indexOfSubCollection:( '\plain\' ) ) = 0
			]
		) mifNotNil:[ :theRTFStr :plainFirstBlk |
			(
			(
			(
			(
			( 
			( theRTFStr asCharacter <---------------------------( singular is plural style )
			) replaceAll:#( '\plain\' )with:#( ' \plain\' ) 
			) asString asStringGenerator subStringsWithBlanks
			) pairUpAllNeighbors:[ :word :nextWord | 
				( plainFirstBlk value:( nextWord ) 
				) ifTrue:[ word copyFrom:( 1 )to:( word size - 1 ) ]
			  ]
			) sectionsStartingWith:( plainFirstBlk )
			) collect:[ :oc | oc asArray ] <----------------( must copy the reused oc bag )
			) asOrderedCollection
		]

	)-subSections.    Note the linear indentation style.  And imagine what a mess this
	thing would be if the linear indentation style was not used.  Also note the
	Lambda Calculus functional style of making local variables by using function
	input parameters as exampled by the use of Object>>ifNotNil: where the input
	parameters :theRTFStr and :plainFirstBlk are used as a temporary local variables.
	I sometimes use this style just for fun.  Sometimes it can be useful to clean things
	up.  But mostly I would be forced to use regular local variables because they are
	faster.  Some might want
	to collapse the initial 5 empty leftParens into something like ((((( , but I find the
	white space to be more relaxing.  Like they do in coffee table books.  Damn if 
	the whole thing isn't white space.  One 351 page book of blank white pages.
	But hay, feel that paper!!  That's real monochromed 300lb weight,    that.
	The sequence of OrderedCollection ''bags'' returned by >>sectionsStartingWith: is
	actually all the same bag but with possibly different contents for each slot place it is
	at in the sequence returned so when you want to make asOrderedCollection then
	you have to make copys of the bag in order to get it to exist in memory as multiple
	bags all symultaineously existing.  the one bag is reused as a memory and speed saving
	device, as is commonly done in the implementation of Generator creation methods.
	Generators have a Stream like ability to save on memory, except even more so.  But
	with RAM so cheap nowadays, one almost has to ask: why bother.
	String>>asCharacter returns a Generator on a Stream of Characters in the original
	String, as per the singular is plural Generator style.
	Array>>mifNotNil: is like-:( Object>>ifNotNil: UndefinedObject>>ifNotNil: )
	but is used with BlockClosures with multiple input parameters like the-:(
		[ :theRTFStr and :plainFirstBlk | ... ]
	)Block used above.  Via the BlockClosure>>valueWithArguments: function.

 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(

		( ( ( #(  ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  ) )

		( ( ( #( 1 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  ) ( 1 ) )

		( ( ( ( #( 1 ) asGenerator sectionsStartingWith:( 1 ) ) removeFirst ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 ) )

		( ( ( #( 2 3 1 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 ) )

		( ( ( #( 2 3 1 4 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 ) )

		( ( ( #( 2 3 1 4 5 1 1 1 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 5 ) ( 1 ) ( 1 ) ( 1 ) )

		( ( ( #( 2 3 1 4 5 1 1 1 6 7 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 5 ) ( 1 ) ( 1 ) ( 1 6 7 ) )

		( ( ( #(  ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  ) )

		( ( ( #( 1 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  ) ( 1 ) )

		( ( ( ( #( 1 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) removeFirst ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 ) )

		( ( ( #( 2 3 1 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 ) )

		( ( ( #( 2 3 1 4 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 ) )

		( ( ( #( 2 3 1 4 5 1 1 1 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 5 ) ( 1 ) ( 1 ) ( 1 ) )

		( ( ( #( 2 3 1 4 5 1 1 1 6 7 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 5 ) ( 1 ) ( 1 ) ( 1 6 7 ) )

		( ( ( ( 'a car a bus a truck' asSequence ) sectionsStartingWith:( $a ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  )( $a $  $c )( $a $r $ )( $a $  $b $u $s $ )( $a $  $t $r $u $c $k ) )

		( ( ( ( 'a car a bus a truck' asSequence ) sectionsStartingWith:[ :c | c = $a ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  )( $a $  $c )( $a $r $ )( $a $  $b $u $s $ )( $a $  $t $r $u $c $k ) )

		(
		(
		(
		( 'a car a bus a truck' asCharacter 
		) sectionsStartingWith:( $a )
		) collect:[ :oc | oc asArray ] 
		) asArray
		) =
		#(	(  )
			( $a $  $c ) 
			( $a $r $ )
			( $a $  $b $u $s $ ) 
			( $a $  $t $r $u $c $k )
		)


 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	Here is a lot of unrelated malarcky that is being left here in case anybody does
	a search like-:( ( on any ClassHierarchyBrowser )=> <Alt>=> <M>(Method)=> 
		<B>(Browse...)=> <O>( Method Text... )=> ( enter-: 'KEGParam' without
		the quotes )=> <Enter> )-asearchlike
	Please note that P is the Abreviation for KEGParam and in order to get access
	to this abreviation you must include the Abreviations( [_]: should be
	changed to KEGAbreviations ) in the poolDictionaries: of the Class you are
	creating a method for.  See the KEGGenerator Class definition for an example.

	Now you should also note that anObject can be a KEGParam so it can
	participate in the KEGParameter patterns protocals.  As of today
	<D:20020423> if anObject isParam then anObject is expected to have the
	following form-: aKEGParam( aMonadicValuable )
	where aMonadicValuable is anything that responds to the >>value: message.

 )-rants )-defineMethod"! !

!KEGGenerator methodsFor: '*KEGGeneratorFiniteStateMachines' stamp: 'KjellGodo 6/8/2013 21:20'!
"(| defineMethod-:(" sortInto: aKEGRuleBaseParam ")
	notes-:(		Method Version: keg9.
				 Copyright Kjell E God Sep  6 1998
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030410, 20030321, 20030212,
	20010731, 20010121, Mar 22 1999, Sep  6 1998
	)-notes methodBody-:(
 (| let-:("| resetMainSequence anIndexedCollection bags selectors selector states
	oldStateIndex presentStateIndex nextStateIndex returnedBag return returnBag
	returnBlk presentBag aFooArray seqTerminationMarker stopNow |") <---( KEG8-: added stopNow )
    letBody-:("					"( MT b:#sortInto: s:self )."

	( anIndexedCollection := aKEGRuleBaseParam isParam
		ifTrue:[ aKEGRuleBaseParam ]ifFalse:[ aKEGRuleBaseParam asOrderedCollection ] 
	).
	( bags := anIndexedCollection collect:[ :n | OrderedCollection new ] ).
	( selectors := anIndexedCollection collect:[ :x | x key"TestBlocks" ] ).
	( states := anIndexedCollection collect:[ :x | x value"StateBlocks" ] ).
	( anIndexedCollection do:[ :x | x isParam ifTrue:[ x removeAll ] ] ).
	( anIndexedCollection isParam ifTrue:[ anIndexedCollection removeAll ] ).

	( resetMainSequence := self abstractGenerator new
		resetBlock:[ presentStateIndex := 1"FirstState" .  returnedBag := false .
			selector := selectors at:1"FirstSelector" .  bags do:[ :x | x removeAll ] .
			self reset ]
		nextBlock:[ self next ] 
	).
	( seqTerminationMarker :=( aFooArray:=KEGFooArray new )asSingletonGenerator ).

	returnBlk := [
		( returnBag := bags at:( presentStateIndex ) ).
		(
		( return := 
		( states at:( presentStateIndex )
		) value:( returnBag )value:( #result"Bag" )
		) = #result"Bag"
		) ifTrue:[ returnBag ]
		 ifFalse:[ ( return == KEGFooArray )ifTrue:[ aFooArray ]ifFalse:[ return ] ] "<----------( KEG5: Continue to support the old way where if returnBlk returned KEGFooArray then no bag would be returned for the present state and we continue onto the next state. )"
	] .
	^(
		( resetMainSequence , seqTerminationMarker )collect:[ :x | "D d:?. <-----( break point to debug KEGMiscScripts>>trade: . KEG6. )"
			( returnedBag ifTrue:[ 
				( ( bags at:( oldStateIndex ) ) removeAll ).
				( returnedBag := false ).( presentStateIndex := nextStateIndex ) ] 
			)."........................."
			( 
			( x == aFooArray "<-------------------------------------------------------------------------------( self has run out and returned nil. So clean up and return the last bag. )( KEG5 )"
			) ifFalse:[ 
				( selector value:( x )
				) ifNil:[ stopNow := true ]ifNotNil:[ :nextSI | "<----------------------( KEG7. KEG8-: changed 'stop' to 'stopNow' . )"
					(
					( nextSI isParam "<---( KEG9: We use isParam instead of isKindOf: Array because isParam is more of a Type thing than isKindOf: and can define a Type of Objects across multiple different Classes subHierarchies of Object .  But I think that in Dolphin isKindOf: is actually twice as fast.  Or something.  Oh well.  We go for flexibility instead. )"
					) ifTrue:[ ( nextStateIndex := ( nextSI  p1 ) ). presentStateIndex ] "<------( KEG9: This presentStateIndex is a little iffy.  But it seems to work.  The other stuff seems more localized and easier to verify and understand and track.  But the test cases made so far work so I guess it works. )"
					  ifFalse:[ ( nextStateIndex := nextSI )return:( presentBag := bags at:( nextStateIndex ) ) ] "<-------( KEG9: Oldat:Code-: nextStateIndex := nextSI )"
					) ifNotNil:[ :stuffItIntoState | "<---------( KEG9 )"
						(
						(
						( states at:( stuffItIntoState ) "<------( KEG9: Was-: nextStateIndex )"
						) value:( presentBag )value:( x )
						) ifNotNil:[ :valval | ( valval == KEGFooArray )ifFalse:[ ( bags at:( stuffItIntoState ) ) add: valval ] ]
						).
						( presentBag := bags at:( nextStateIndex ) ) "<----------( KEG9:  Have to redo this in case the ( nextSI at:1 ) case was done. )"
					  ]
				]"-ifNotNil:" ]"-ifFalse:"
			)."......................" "<----------------------------------------------------( KEG4: Changed #sortInto:''Bag'' into presentBag. )"
			(
			( stopNow == true "<-----------------------------------( KEG8: change 'stop' to 'stopNow == true' since stop might be set to true by other things than the ifNil:ifNotNil: above so we don't want to get screwed up by those or screw those up.  In fact stop is for self and not for the returned KEGGenerator!!  So when self runs out of elements then stop goes to true.  Prior to the ifNil:ifNotNil: above.  Which is not the kind of signaling we had in mind when we did change KEG7.  We had in mind a stop flag that would be totally local to the KEGGenerator returned by self-:( this method ).  We use == true because it combines the isNil functionality.  So if stopNow is nil you get the same reaction as when stopNow is false.  So you don't have to make sure to initialize stopNow to false.  You can just leave it as nil and that initializes it.  So here we think like nil == false .  So nil becomes a Boolean and is equal to false in functionality.  And finally, this change will eliminate the bug where self runs out of elements and then the present bag, for the present state, presently being filled by the elements of self( or whatever other elements ) never gets returned below.  And we want the present bag to be returned. )"
			) ifFalse:[ "<----------------------------------------------( KEG7: stop is never nil so we don't have to use the stop == true way. )"
				(
				( x == aFooArray 
				) ifTrue:[ returnBlk value ]ifFalse:[ "<---------------------------------------( self has run out and returned nil. So clean up and return the last bag. )( KEG5 )"
					( nextStateIndex = presentStateIndex ) "<---------------------------------------------------( and:[ x ~= FooArray ] )"
						ifTrue:[ aFooArray ] "<------------------------------------------------------------------( keep the elements of self coming, don't return anything yet. )( KEG5 )"
						ifFalse:[ 
							( selector := ( selectors at:( nextStateIndex ) ) ).
							( returnedBag := true ).
							( oldStateIndex := presentStateIndex ).
							( returnBlk value ) ] ]
				)
			]"-stop==trueifFalse:"
			)
		]ignoring:( aFooArray )"<-----------------------------------------------------------------------------( KEG5 )"

	)"return:( 					MT e:#sortInto: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(
	There is no methodDescriptionSummary possible for self-:( this method ) but here
	and let me try-:
	self-:( this method ) makes and returns a new Generator G which is a
	Finite State Machine( FSM ) like what you have seen in any compiler class
	in any computer science section at any college that has one, Or having been
	excluded from every college by the expensive quota system from hell, where it's
	WE DON'T HAVE ENOUGH MONEY-:( don't spare the horses man, step on it ),
	( dump that budget down a rat hole, if you please, i/they/we want to hit the speed
	of sound before the crack ) ie: having been so excluded : if ever you just went
	ahead and picked up a book on Compilers from Amazon.com or whereEver
	THEN: you would have seen the FSMs in there in the front of that compiler
	( or finite automata ) book.  phew!!
	How it does that is a matter of details, Lots and Lots
	of details.  Of which as of <D:20030212> most of them are now lost in the
	<<See Zoomer FILE: c:\teleagnt\text\paperfil.zmr AT:  >> dump in Smalltalk/V 2.0
	I think.  ( probably could do with a redoing anyway. )  But for now you can look
	at all the uses of >>sortInto: by Browsing the Senders of >>sortInto: or in
	Dolphin Smalltalk the References to >>sortInto: .
 )-summary
 methodDescriptionDetail-:(

	sortInto: works like this-:		( now take a deep breath. hold it hold it holdit,
	you feel that? well get used to it... )
	You take a base Generator called aGen.  You want to make a Finite State Machine
	out of it ( a FSM ).  So you expectorate thus-:

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	Now if aGen was a Generator sequence of Characters as can be made by
	( aString asSequence ) then this new Generator r would return OrderedCollection
	''bags'' that had the period seperated sentences in them.  But the first element of the
	first bag would probably not be a $. Character but the first element of each bag
	after that would have $. as the first element.  So if you wanted the periods to
	go at the ends then you could do-:(

		( r sectionPrefixes:1fromSuffixes:1 )

	) to get a new Generator sequence that has the periods at the end of each sentence.
	You could also in this case do-:(
		aGen sectionsEndingWith:( $. )
	) but okay.  It's just an example.  So how does-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	)work?  Well, each when:here:whenLeaving: creates a numbered state in the
	r Generator.  The first state to run is state 1.  Marked ''1'' above.  So first the
	when: Block executes and returns nextState.  Now if nextState = 1 then the
	here: Block of state 1 is evaluated as nil = [ :bag :x | x ] so the x is just returned
	unchanged and is stuck into the bag( OrderedCollection ) for state 1.  Now as long
	as x is not = $. then all these x's just keep getting stuffed into the bag for state 1.
	But as soon as x = $. then state 1's here: block returns 2 which means we are
	switching to state 2.  So immediately this latest period x is dumped into the
	here: block of state 2 which dumps it into the bag for state 2.  Next the
	whenLeaving: block ( nil = [ :bag | bag ] ) is evaluated with the bag for state 1
	as its input parameter :bag and in this case the bag for state 1 is just returned by
	( r next ) .   So how is it that r does all of these things? in what context?  Well it is in
	some context where the >>next message gets sent to r over and over like in the
		( r last )
	expression or ( r asArray ) or ( r do:[ :x | ... ] ) or ( r inject:( ... )into:[ :v :x | ... ] )
	or ( r asString ) etc.
	And thus it continues until aGen has no more elements in it.  Now it should be
	noted that all the OrderedCollection bags returned by a single state are the same
	bag returned over and over with different contents each time.  So if you want to
	do an ( r asOrderedCollection ) you will have to do it like-:(
		( r collect:[ :oc | oc copy ]
		) asOrderedCollection
	) in order to get all the OrderedCollections to stay in MEMORY at the same time.
	Otherwise you will get some crazy funk you won't soon figure out unless you know
	this here ''should be noted'' is the case.  Also you can please note that in-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	) the two states are almost mirror images of each other.  This is often the case
	and such mirror images can be thought of as a single super state where mostly
	it just loops back into itself doing nothing.  But sometimes it wants to output
	what it has so far and start on a new bag.  In such cases you use switched mirrored
	states like above.   Now we can also have states that are exact mirrors of each
	othere like-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	)now this would return bags that were single sentences but without any
	trailing period.  And the trailing period would be stuck into its own bag and
	returned all by itself.  During a 
		( stringGen := KEGGenerator streamGenerator asStringGenerator ).
		( ( r collect:[ :oc | ( stringGen on:( oc ) ) asString ] ) asArray )
	operation for example( which only allocates the stringGen once and then
	reuses it over and over to create each String. ).
	( Now these examples are somewhat pathological since why not just use
		Stream>>upToIncluding:( $. )
	to do the same thing?  Yes you probably would.  But okay quit raining on my
	parade here, I just wanted something simple.  Okay? )
	So it turns out that the exact mirror image version is probably actually better for
	us here than the switched mirror image version above since we probably don't
	have to do any funny stuff to get the $. prefix off the beginning of each bag
	if we don't want it to be there.

	Now suppose you wanted to switch states without sending the present state's
	here: block's x to the next state?  Suppose instead you wanted the x to be stuffed
	into the present state's here: block and then switch states to the next state?
	Like if you were going from state 1 to state 2 because x = $.  Then you could do-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ #( 2 ) ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ #( 1 ) ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	) in which case when we are switching from state 1 to state 2 because x = $. then
	the $. goes into the bag for state 1 and then the bag for state 1 is returned. And then
	on the next ( r next ) call state 2 starts up on the next x in the base sequence.
	Now we have solved the problem of the $. not being on the end of the sentences
	we want to find and return.

	Now you're not supposed to do this but suppose you just wanted to peek
	at x and then switch to some other state to have that state process the x.
	WELL DON'T DO IT!!!!!!						( just kidding )
	Perhaps something like-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ #( peek 2 ) ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ #( peek 1 ) ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	)could do the job.   Except that now you get into an infinite loop as soon as you hit
	the first $. in line.  oooooooh no good.  But if the states were not mirrored it might
	work.  But that is not supposed to be the style of sortInto: finite state machines.
	You are not supposed to want to peek.
	( But on the other hand, perhaps it could be argued that peeking might make
		certain situations more code minimal. )
	No you are NOT supposed to be doing this kind of peeking
	because every state should be able to jump directly to any other state and process
	any other state's junk.  So for this reason you like to use BlockClosures sometimes
	a lot to make multiple state's here: blocks and other blocks be able to do exactly
	the same thing.  So like we might make-:(
		( checkForPeriodBlk := 
			[ :x :i :j | ( x = $. )ifTrue:[ i ]ifFalse:[ j ] ] ).
	)and then do-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | checkForPeriodBlk p:( x )p:( 2 )p:( 1 ) ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | checkForPeriodBlk p:( x )p:( 1 )p:( 2 ) ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	) where >>p:p:p: = >>with:with:with: .  Which is another pathological example
	that you would never actually do probably but it shows the idea.

	Sometimes you might want a state you are switching to to know what the state you
	just came from was.  In that case you can use Boolean flags-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ lastStateWas:=1. 2 ]ifFalse:[ 1 ] ]
		here:[ :bag :x | lastStateWas=2 ifTrue:[ ... ]ifFalse:[ ... ] ]whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ lastStateWas:=2. 1 ]ifFalse:[ 2 ] ]
		here:[ :bag :x | lastStateWas=1ifTrue:[ ... ]ifFalse:[ ... ] ]whenLeaving:( nil )
		)
	)
	)

	) which is somewhat pathological because we have just two states so we always
	know which state we are coming from but again, give me a break.

	Or perhaps self-:( this method ) could be modified so that you could do-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ #( 2 lastStateWas: 1 ) ]ifFalse:[ 1 ] ]
		here:[ :bag :x :last | last=2ifTrue:[...]ifFalse:[...] ]whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ #( 1 lastStateWas: 2 ) ]ifFalse:[ 2 ] ]
		here:[ :bag :x :last | last=1ifTrue:[...]ifFalse:[...] ]whenLeaving:( nil )
		)
	)
	)

	)in which case sortInto: would have to be able to notice how many parameters
	the here: block was taking which it could do.  If I wanted to worrry.  What me
	worry?

	If KEGFooArray is returned 
	by the whenLeaving: Block during a change of state from the present FSM state
	to a new FSM state( ie: KEGFooArray in place of the customary bag )
	THEN-: nothing is returned by the Generator r in response to the present
	( r next ) message that r is in the middle of and then r continues on to the next
	state.  ( ie: the present >>next message that r is in the middle of doesn't return
	like it would if a bag was returned by the present whenLeaving: block but instead
	goes on to the next FSM state.

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:[ :bag | KEGFooArray ] ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	). ( See
	KEGRuleBaseParam>>when:here:whenLeaving: ) )

	( self-:( this method ) returns a new KEGGenerator G ( ie: let it be called G ).
	Then-: as of <D:20030212> when the nextState selector here: Block returns nil
	instead of the customary Natural Integer or Array with a Natural Integer in it
	THEN-: the Generator G returned will stop and the ( G next ) message call that
	G is in the middle of then will return nil and all the ( G next ) messages sent to
	G after that will also return nil until G is
	reset via the ( G reset ) message.

	
	( G :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:[ :bag | KEGFooArray ] ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ nil ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	)-<D:20030212>

	( comment:-- ( 20130602 yyyymmdd ) 
		
	( G :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]
		here:[ :bag :x | KEGFooArray ]whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ nil ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)
	If you return KEGFooArray from the here: Block like
	[ :bag :x | KEGFooArray ] as shown above then nothing is added to bag.

	)---[ comment 20130602 ]

	( When ignoring the person specific initials KEG
	as if there may be other Generator classes or subClasses made by other
	people besides KEG then I just leave the KEG off.  Because of lazy typing or
	something. )

	<<See Zoomer FILE: c:\teleagnt\text\paperfil.zmr AT:  >>
	or select the following-: << See HelpString AT-: 7 >> and do-:
	RightClick=> Manipulate...=> ===> Get Text Pointed At by Selection .

	KEG5: Replaced KEGFooArray with aFooArray because
	KEGFooArray can legally exist in self as regular parts of the self data sequence.
	So we need something more unique to self-:( this method ) to mark the end of self.
	Also replaced KEGFooArray with aFooArray in the ignore: stuff above for the
	same reason.  Also kept up the functionality where if KEGFooArray is returned 
	by the whenLeaving: Block during a change of state from the present FSM state
	to a new FSM state( ie: KEGFooArray in place of the customary bag )
	THEN-: nothing is returned by the Generator G in response to the present
	>>next message that G is in the middle of and then G continues on to the next
	state.  ( ie: the present >>next message that G is in the middle of doesn't return
	like it would if a bag was returned by the present whenLeaving: block but instead
	goes on to the next FSM state ). ( See
	KEGRuleBaseParam>>when:here:whenLeaving: ) )

	KEG6: ( <D:20010731> ? )
	Changed-:(
		'KEGFooArray new )asGenerator' 
	) to-:(
		'KEGFooArray new )asSingletonGenerator'
	)
	because a FooArray is an Array so sending an empty Array >>asGenerator just
	returns an empty Generator which just returns nothing but nil when you send it
	the >>first and >>next messages so that is why the last returnBag was never
	being returned because ( x == aFooArray ) was never returning true because the
	#, concatenation Generator was always returning nil instead of the
	FooArray.
	It should return the FooArray as it did before KEG5 above. Before KEG5 it
	returned the KEGFooArray Class and sending that >>asGenerator returned a
	singleton Generator with KEGFooArray as its only element.  Now when we use
	asSingletonGenerator we get back to that functionality.  It is strange that this bug
	never was a serious problem.  And fixing it now was an aside in order to fix the
	KEGMiscScripts>>add: which had the problem of cutting off the last todo
	for a long time. But I just lived with it.
	( other KEG changes are listed below in one of the new changes sections now
	being used in this PicoLARC style of method documentation. )
 )-detail
 usage-:(

	Check out the References or SendersOf self-:( this method ) for usage examples
	and especially the following that have more detailed documentations-:(
		KEGAccountKeepTrackerPosition>>asColoredWordsV2:
	)and also try to look for References of self-:( this method ) that have a lot of
	comments in and amongst the sortInto: Finite State Machine states.  Also try to
	look for References that use the >>when:here:whenLeaving: or
	>>when:here:leaving: methods to set up the FSM states.
	The ones that use the >>when:perform: way may be a lot harder to understand
	as they were made in the bad old days before there was
	>>when:here:whenLeaving: which cleaned things up a lot.

 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'KEGGenerator>>sortInto:' )
 )-todebug
 todos-:(

	( [_]:[]:WK SMALLTALK-: Dolphin Smalltalk-:
		Encapsulate the guts of self-:( this method ) in a special current
		instance of a special KEGGenerator subClass
		KEGSortInto Class such that speed optimizations
		can be had and so that the guts of this thing can be encapsulated . )

	( [_]:[]:WK SMALLTALK-: Dolphin Smalltalk-:
		In an example to do with
		KEGTextGenerator>>asOrderedCollection
		it says:
		Here we attatch something onto the front of the Collection
		returned by
		sortInto:
		which is supposed to describe the whole Collection.  And it is a
		mess. a bit.  So this may well be why they always tell you not to
		return elementary Objects like Arrays and Dictionaries and
		such but rather to encapsulate those in special Objects that
		can easily be made to carry extra info about the Collection as
		a whole.  Now it is true that sortInto: always wants to return a
		Generator that always returns OrderedCollections, but via a
		Block like the returnBlk and testing for c = #result one can
		wrap the OC in a special Object just before it is returned.  But
		this too is a bit more messy perhaps than one wants.  One could
		refactor sortInto: into >>sortInto: and >>sortInto:on:
		where >>sortInto: just calls >>sortInto:on: with
		OrderedCollection or [ OrderedCollection new ] as the on:
		parameter.  And the on: parameter tells what the returned
		value is going to be.  Yes.  I like that idea.  I will try to note it in
		KEGGenerator>>sortInto: now . )

 )-todos
 changes-:(
	(| KEG8-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg8
	or
	(| KEG9-:( Changes onDate-:( ... ) theOldCode-:( ... ) wasReplacedBy-:( ... ) )-chg )-keg9
	. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
	(| KEG9-:( Changes onDate-:( <D:20030410> ) madeChanges-:(
		Added the-:(   nextSI isParam   )and-:( ifNotNil:[ :stuffItIntoState | )
		stuff.  To allow next state Integers to be surrounded by Arrays etc.
		)-madechanges )-chg )-keg9

	(| KEG8-:( Changes onDate-:( <D:20030321> ) theOldCode-:( 'stop' )
		wasReplacedBy-:( 'stopNow' ) and-:( 'stopNow == true' ) and stopNow
		was added as a new local variable in order that the present bag of the
		present state might be returned if self runs out of elements.
	)-chg )-keg8

	(| KEG7-:( Changes onDate-:( <D:20030212> ) madeChanges-:( 
		converted self-:( this method ) over to PicoLARC style and added the
		'ifNil:[ stop := true ]ifNotNil:[ :nextSI |' stuff and the '( stop )ifFalse:'
		stuff so that now if the selector Block( monadicValuable ) returns nil
		then self will stop and return nil from then on in response to the
		self>>next message. )-madechanges )-chg )-keg7
 )-changes
 testCases-:(

	(
	( '' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) ""<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]""
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #(  ) )

	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) ""<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]""
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( $1 $2 $3 $4 $5 ) #( $. $6 $7 $8 $9 ) #( $. $1 $2 $3 $4 ) )

	Remember that the :oc above is an OrderedCollection that is global to the >>sortInto: created KEGGenerator so if we don't make copies of it then asArray makes
	a mess. But often you don't need to make copies because each copy is discarded before the next iteration and so memory allocations are reduced if we don't copy.
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) ""<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]""
		)
	)
	) asArray asString = '#(an OrderedCollection($. $1 $2 $3 $4) an OrderedCollection() an OrderedCollection($. $1 $2 $3 $4))'

	(
	( '.12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) ""<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]""
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #(  ) #( $. $1 $2 $3 $4 $5 ) #( $. $6 $7 $8 $9 ) #( $. $1 $2 $3 $4 ) ) 

	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:[ :bag :x | x ]whenLeaving:[ :bag | bag ] ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:[ :bag :x | x ]whenLeaving:[ :bag | bag ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( $1 $2 $3 $4 $5 ) #( $. $6 $7 $8 $9 ) #( $. $1 $2 $3 $4 ) )

	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:[ :bag :x | x ]whenLeaving:[ :bag | bag add: 1 ; yourself ] ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:[ :bag :x | x ]whenLeaving:[ :bag | bag add: 2 ; yourself ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( $1 $2 $3 $4 $5 1 ) #( $. $6 $7 $8 $9 2 ) #( $. $1 $2 $3 $4 1 ) )

	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:[ :bag :x | ( bag add: 1.0 ).( x ) ]whenLeaving:[ :bag | bag add: 1 ; yourself ] ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:[ :bag :x | ( bag add: 2.0 ).( x ) ]whenLeaving:[ :bag | bag add: 2 ; yourself ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( 1.0 $1 1.0 $2 1.0 $3 1.0 $4 1.0 $5 1 ) #( 2.0 $. 2.0 $6 2.0 $7 2.0 $8 2.0 $9 2) #( 1.0 $. 1.0 $1 1.0 $2 1.0 $3 1.0 $4 1) )

	(
	( '.12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:[ :bag :x | ( bag add: 1.0 ).( x ) ]whenLeaving:[ :bag | bag add: 1 ; yourself ] ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:[ :bag :x | ( bag add: 2.0 ).( x ) ]whenLeaving:[ :bag | bag add: 2 ; yourself ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( 1 ) #( 2.0 $. 2.0 $1 2.0 $2 2.0 $3 2.0 $4 2.0 $5 2 ) #( 1.0 $. 1.0 $6 1.0 $7 1.0 $8 1.0 $9 1 ) #( 2.0 $. 2.0 $1 2.0 $2 2.0 $3 2.0 $4 2 ) )

	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ #( 2 ) ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ #( 1 ) ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil )
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( $1 $2 $3 $4 $5 $. ) #( $6 $7 $8 $9 $. ) #( $1 $2 $3 $4 ) )

	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ #( 2 ) ]ifFalse:[ 1 ] ]here:[ :bag :x | ( bag add: 1.0 ).( x ) ]whenLeaving:[ :bag | bag add: 1 ; yourself ] ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ #( 1 ) ]ifFalse:[ 2 ] ]here:[ :bag :x | ( bag add: 2.0 ).( x ) ]whenLeaving:[ :bag | bag add: 2 ; yourself ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( 1.0 $1 1.0 $2 1.0 $3 1.0 $4 1.0 $5 1.0 $. 1 ) #( 2.0 $6 2.0 $7 2.0 $8 2.0 $9 2.0 $. 2 ) #( 1.0 $1 1.0 $2 1.0 $3 1.0 $4 1 ) )

	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ #( 2 ) ]ifFalse:[ 1 ] ]here:[ :bag :x | KEGFooArray ]whenLeaving:[ :bag | bag add: 1 ; yourself ] ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ #( 1 ) ]ifFalse:[ 2 ] ]here:[ :bag :x | ( bag add: 2.0 ).( x ) ]whenLeaving:[ :bag | bag add: 2 ; yourself ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( 1 ) #( 2.0 $6 2.0 $7 2.0 $8 2.0 $9 2.0 $. 2 ) #( 1 ) )

	See the test Method KEGGeneratorTest>>testsortIntoC for examples of returning nil or KEGFooArray instead of the :bag and some other things.

 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGenerator methodsFor: '*KEGGeneratorFiniteStateMachines' stamp: 'KjellGodo 6/8/2013 21:22'!
sortIntoChangeOCsToGenerators

	"Method Version: keg1.  "
	" Copyright Kjell E God Jun 11 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Jun 11 2000"
	| answer gen |
						"MT b:#sortIntoChangeOCsToGenerators s:self."

	gen := KEGGenerator streamGenerator .
	answer := self collect:[ :oc | oc asStreamGeneratorOn: gen ] .

						"MT e:#sortIntoChangeOCsToGenerators s:self."
	^answer .

	"This method can be used after the self>>sortInto: method to convert the reused
	OrderedCollection OC returned by the Generator G returned by the self>>sortInto: method
	into Generators OCG in a somewhat efficient way by reusing the returned Generator OCG.
	self>>sortInto: returns G.  G returns OC.  ( G sortIntoChangeOCsToGenerators ) returns
	a Generator GG.  GG returns OCG over and over again with different contents each time."

	"

	( self assert:(
	(
	( '' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) ""<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]""
		)
	) sortIntoChangeOCsToGenerators collect:[ :oc | oc asArray ]
	) asArray = #( #(  ) )
	) description:( ' >>sortIntoChangeOCsToGenerators 1 the empty case' ) ).

	( self assert:(
	(
	( '' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) ""<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]""
		)
	) sortIntoChangeOCsToGenerators
	) asArray asString = '#(a KEGGenerator)'
	) description:( ' >>sortIntoChangeOCsToGenerators 1 the empty case' ) ).

	( self assert:(
	(
	( '12345' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) ""<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]""
		)
	) sortIntoChangeOCsToGenerators collect:[ :oc | oc asArray ]
	) asArray = #( ( $1 $2 $3 $4 $5 ) )
	) description:( ' >>sortIntoChangeOCsToGenerators 2 showing no state change case' ) ).

	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) ""<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]""
		)
	) sortIntoChangeOCsToGenerators collect:[ :oc | oc asArray ]
	) asArray = #( #( $1 $2 $3 $4 $5 ) #( $. $6 $7 $8 $9 ) #( $. $1 $2 $3 $4 ) )
	) description:( ' >>sortIntoChangeOCsToGenerators 2 showing case you think of first' ) ).
	
	"! !

!KEGGenerator methodsFor: '*KEGGeneratorFiniteStateMachines' stamp: 'KjellGodo 6/8/2013 21:24'!
sortIntoChangeOCsToStringGenerators 

	"Method Version: keg1.  "
	" Copyright Kjell E God Jun 11 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Jun 11 2000"
	| answer gen stGen |
						"MT b:#sortIntoChangeOCsToStringGenerators s:self."

	stGen := ( gen := KEGGenerator streamGenerator ) asStringGenerator .
	answer := self collect:[ :oc | oc asStreamGeneratorOn: gen . stGen ] .

						"MT e:#sortIntoChangeOCsToStringGenerators s:self."
	^answer .
	"This method can be used after the self>>sortInto: method to convert the reused
	OrderedCollection OC returned by the Generator G returned by the self>>sortInto: method
	into StringGenerators OCSG in a somewhat efficient way by reusing the returned Generator OCSG.
	self>>sortInto: returns G.  G returns OC over and over again with different contents.
	( G sortIntoChangeOCsToStringGenerators ) returns a Generator GSG.  GSG returns
	OCSG over and over again with different contents each time.  To get a KEGGenerator
	to return things first you send it the >>reset message and then the >>next message over
	and over.  Usually an iteration message like KEGGenerator>>do: is used to do this."

	"
	( ( Smalltalk at: #KEGStringGenerator ifAbsent:[  ] ) notNil ifTrue:[

	( self assert:(
	(
	( '' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) ""<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]""
		)
	) sortIntoChangeOCsToStringGenerators collect:[ :gen | gen asArray ]
	) asArray = #( #(  ) )
	) description:( ' >>sortIntoChangeOCsToStringGenerators 1 the empty case' ) ).

	( self assert:(
	(
	( '' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) ""<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]""
		)
	) sortIntoChangeOCsToStringGenerators
	) asArray asString = '#(a KEGStringGenerator)'
	) description:( ' >>sortIntoChangeOCsToStringGenerators 1 the empty case' ) ).

	( self assert:(
	(
	( '12345' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) ""<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]""
		)
	) sortIntoChangeOCsToStringGenerators collect:[ :gen | gen asArray ]
	) asArray = #( ( $1 $2 $3 $4 $5 ) ) ""<---[ KEGStringGenerators leave Characters alone ]""
	) description:( ' >>sortIntoChangeOCsToStringGenerators 2 showing no state change case' ) ).

	( self assert:(
	(
	( #( 1 2 3 4 5 ) asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) ""<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]""
		)
	) sortIntoChangeOCsToStringGenerators collect:[ :gen | gen asArray ]
	) asArray = #( ( '1' '2' '3' '4' '5' ) ) ""<---[ KEGStringGenerators turn everything into Strings ]""
	) description:( ' >>sortIntoChangeOCsToStringGenerators 2 showing no state change case and String conversions ' ) ).

	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   ""1""when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   ""2""when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) ""<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]""
		)
	) sortIntoChangeOCsToStringGenerators collect:[ :gen | gen asArray ]
	) asArray = #( #( $1 $2 $3 $4 $5 ) #( $. $6 $7 $8 $9 ) #( $. $1 $2 $3 $4 ) )
	) description:( ' >>sortIntoChangeOCsToStringGenerators 2 showing case you think of first' ) )

	] ).""<---[ ifTrue: ]""
	
	"! !

Object subclass: #KEGGeneratorFiniteStateMachinesPackageComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KEGGeneratorFiniteStateMachines'!

!KEGGeneratorFiniteStateMachinesPackageComment commentStamp: '<historical>' prior: 0!
KEGGeneratorFiniteStateMachines Package provides 
	simple Finite State Machines that can be created in a
	few lines of code on Generators that can be convenient
	where very high runtime speed is not needed and where small 
	simple source code is desired and where the full functionality
	of KEGGenerators can be used
	for the KEG Smalltalk software & software codes.
	Copyright  2001  Kjell E God

	This Package is licensed as MIT Open Source.  Please evaluate ( Object licenseMIT ) for more info
	or see KEGLicense class>>licenseMIT.

( comment:-- ( 20130608 yyyymmdd )

	The main way of creating finite state machines here is by using the
	KEGGenerator>>sortInto: method.  You take any sequence of Objects
	and convert it into a KEGGenerator if it isn't one already and then you
	can create a finite state machine r on that sequence s where r has
	multiple states and transitions between those states.
	Also there are actions that can be taken like putting each element of
	the source sequence s into an OrderedCollection for the present state.  
	Each state has its own OrderedCollection which I will call the state's bag.
	So as r is iterating like via the ( r asArray ) message the elements of
	the source sequence are placed in the different bags for the different
	states.  So as r goes along it can put the elements of the source sequence s
	into the different bags of r.  When leaving a state the bag for that state can
	be returned by r .  Note that each state has just one bag which can be
	returned by ( r next ) multiple times with different contents each time.  
	This cuts down on memory allocations.  Or you can do 
	( r collect:[ :oc | oc copy ] )
	if you need the state bags to persist.  These bags can be returned or not
	depending on what you want.  Or only certain states might return a bag.
	Or the bags might not be used at all.
	>>sortInto: is powered by monadic and diadicValuables( anything that
	respondsTo: #value: or #value:value: like [ :x | ... ] and [ :bag :x | ... ] ) 
	and so you can do arbitrary computations between or at the various states.

	See the KEGGenerator>>finiteSMParseLeftParenV1:rightParen:collect:
	Method for an example of what can be done if you put a stack into a
	finite state machine.  You can do simple shift reduce parsing.  As can
	be seen in the KEGGenerator>>finiteStateMachineParseParensV1
	Method and it's tests.

	Also see the
	KEGGenerator>>finiteSMParseXMLTags:collect:
	KEGGenerator>>finiteSMParseXMLTags
	KEGGenerator>>finiteSMParseXML:
	KEGGenerator>>finiteSMParseHTML
	Methods for examples of how >>sortInto: can be used with or without a
	stack to do simple shift reduce parsing of XML and HTML Strings.
	These examples basically work and there are lots of example tests
	but they need a better list of nonParen tags probably to work better.
	nonParen tags are tags that don't come in pairs like <style>...</style>.
	<link ...> is a nonParen tag.  If there was a complete list of nonParen
	tags then the above Methods should be pretty robust for simple parsing
	into Array trees of tags.  Hopefully there are no tags which are both
	paren and nonParen at the same time.  That would really complicate
	things.
	You can also use 
	KEGGenerator>>finiteSMParseLeftParenV1:rightParen:collect:
	to make trees of other things besides Arrays.  Instead of using Arrays
	for the tree nodes you could use arbitrary Objects for the tree nodes.
	
	Each of the Methods listed above has tests both in the method comments
	of each and in the TestCase method of the same name :

	KEGGeneratorTest>>sortIntoC
	KEGGeneratorTest>>testfiniteSMParseLeftParenV1CrightParenCcollectC
	KEGGeneratorTest>>testfiniteSMParseXMLTagsCcollectC
	KEGGeneratorTest>>testfiniteSMParseXMLTags
	KEGGeneratorTest>>testfiniteSMParseXMLC
	KEGGeneratorTest>>testfiniteSMParseHTML

	Each has lots of >>assert:ed example tests.

	So >>sortInto: is for making basically simple and pretty fast but not blazingly
	fast finite state machines on sequences of objects.  Once you make this r
	finite state machine then since r is a KEGGenerator you can use any of
	the KEGGenerator Methods on r to make even new seqences.

	And when you add a stack into the finite state machine like in
	KEGGenerator>>finiteSMParseLeftParenV1:rightParen:collect:
	or the simpler
	KEGGenerator>>finiteSMParseLeftParen:rightParen:collect:
	then you can do simple shift reduce parsing.  Which can be good if you
	don't want a full blown language parser but just a little parser.

 )---[ comment ]

( comment:-- 20010317

self This Package came about originally in unison with the KEGGenerator>>next:
Method and its ilk.  You can make simple FSMs in a few lines of code that work
for like finding different simple patterns in the lines of a text file.  These FSMs
are not good for making big FSMs.  If you want to make big FSMs that run fast
then turn to the KEGFiniteStateMachineV1-6-0.pac Package instead.





The main workhorse method is the >>sortInto: method as of today ( 20010317 yyyymmdd ).
The other methods are for a new as of yet undebugged way which should be more general and more terse than >>sortInto: .  And including more function points with cleaner code.  As of yet these have not been debugged or used.  One has gotten more used to using >>sortInto: and so the new stuff has been put on hold.

There may be some other related methods scattered around which are not included here yet.  Like in the KEGCanBackup stuff.


-------------------------------------START-PATTERN--------------------------------

PATTERN-: Collect <head><tail> subsequences into sequences of their own 
SITUATION-: For instance if you have the following situation where you have a sequence
	that looks like 	...<head><tail><tail>...<tail><head><tail><tail>...<tail><head><tail><tail>...<tail>...
	and you want to group it like so-:
	( ... )( <head><tail><tail>...<tail> )( <head><tail><tail>...<tail> )... where each ( ... ) is an
	OrderedCollection.  Where <tail><tail>...<tail> is zero or more <tail> elements.

WHAT-YOU-DO-:

	Let's say the initial sequence is in the sourceGen Generator.
	And the resulting grouped sequence that we want is to be in the answer Generator.
	Then-:

	answer := sourceGen sortInto:( KEGRuleBaseParam new
		when:"State1"[ :ln | ( isHeadTest value: x )ifTrue:[ 2 ]ifFalse:[ 1 ] ]   here: nil leaving: nil ;
		when:"State2"[ :ln | ( isHeadTest value: x )ifTrue:[ 1 ]ifFalse:[ 2 ] ]   here: nil leaving: nil 
	) .

	Where headTest is some code which decides whether a sequence element is a <head> or
	a <tail> and returns true if x is a <head> element.  The answer is the desired 
	( ... )( <head><tail><tail>...<tail> )( <head><tail><tail>...<tail> )... where each ( ... ) is an
	OrderedCollection.  There is only one OrderedCollection which is returned over and over by
	the ( answer next ) message.  So if you want more you will have to collect copies by
	doing ( answer collect:[ :oc | oc copy ] ).

	If you wanted the collected sequences to be Generators rather than an
	OrderedCollection that is global to the >>sortInto: and is returned over and over with
	different contents then you would do-:

	answer := sourceGen sortInto:( KEGRuleBaseParam new
		when:"State1"[ :ln | ( isHeadTest value: x )ifTrue:[ 2 ]ifFalse:[ 1 ] ]   here: nil leaving: nil ;
		when:"State2"[ :ln | ( isHeadTest value: x )ifTrue:[ 1 ]ifFalse:[ 2 ] ]   here: nil leaving: nil 
	) .

	answer := answer sortIntoChangeOCsToGenerators .

	If you wanted the collected sequences to be completely nonGlobal new Collections C that
	don't have anything to do with any calculations that were done after the C were created
	then you could do-:

	answer := sourceGen sortInto:( KEGRuleBaseParam new
		when:"State1"[ :ln | ( isHeadTest value: x )ifTrue:[ 2 ]ifFalse:[ 1 ] ]   here: nil leaving: nil ;
		when:"State2"[ :ln | ( isHeadTest value: x )ifTrue:[ 1 ]ifFalse:[ 2 ] ]   here: nil leaving: nil 
	) .

	answer := answer collect:[ :oc | oc asArray ] .

	Which is what you would have to do if you wanted to evaluate the following expression-:
	( answer asOrderedCollection )
	and have it work out right.  Otherwise the fact that the same OrderedCollection is
	returned over and over with different contents each time by the raw sortInto: created
	answer Generator will screw the asOrderedCollection message up and you will not get
	what you want to get.  You want to get each collected sequence is in its own unique
	Collection( ie Array ).  But if you just do-:

	answer := sourceGen sortInto:( KEGRuleBaseParam new
		when:"State1"[ :ln | ( isHeadTest value: x )ifTrue:[ 2 ]ifFalse:[ 1 ] ]   here: nil leaving: nil ;
		when:"State2"[ :ln | ( isHeadTest value: x )ifTrue:[ 1 ]ifFalse:[ 2 ] ]   here: nil leaving: nil 
	) .
	answer := answer asOrderedCollection .

	Then you will get an OrderedCollection where half the OrderedCollections are identical
	to each other as in identical via the == equality.  And you don't want that.  And the other
	half are also identical to each other via == equality.

=======================END-PATTERN======================

The main method of self( this package ) is the KEGGenerator>>sortInto: method.  But thereis a new more general cleaner version also in self( this package ) which hasn't been tested yet which is centered around the new KEGGenerator>>singleSortInto:withBackupAt: method and its helper methods. )---[ comment ]







!
